// NulText.cpp by katahiromz
// This file is public domain software (PDS).
#include <windows.h>
#include <windowsx.h>

void OnPaint(HWND hwnd)
{
    PAINTSTRUCT ps;
    HDC hDC;
    RECT Rect;

    hDC = BeginPaint(hwnd, &ps);
    if (hDC != NULL)
    {
        INT X = 0, Y = 0;
        TextOutA(hDC, X, Y, "\0" "ABC", 4);
        Y += 30;
        TextOutA(hDC, X, Y, "ABC\0", 4);
        Y += 30;
        TextOutW(hDC, X, Y, L"\0" L"ABC", 4);
        Y += 30;
        TextOutW(hDC, X, Y, L"ABC\0", 4);
        X += 80;
        Y = 0;

        UINT uFormat = DT_SINGLELINE | DT_LEFT;
        SetRect(&Rect, X, Y, X + 30, Y + 30);
        DrawTextA(hDC, "\0" "ABC", 4, &Rect, uFormat);
        Y += 30;
        SetRect(&Rect, X, Y, X + 30, Y + 30);
        DrawTextA(hDC, "ABC\0", 4, &Rect, uFormat);
        Y += 30;
        SetRect(&Rect, X, Y, X + 30, Y + 30);
        DrawTextW(hDC, L"\0" L"ABC", 4, &Rect, uFormat);
        Y += 30;
        SetRect(&Rect, X, Y, X + 30, Y + 30);
        DrawTextW(hDC, L"ABC\0", 4, &Rect, uFormat);

        EndPaint(hwnd, &ps);
    }
}

void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id)
    {
        case IDOK:
            EndDialog(hwnd, IDOK);
            break;
        case IDCANCEL:
            EndDialog(hwnd, IDCANCEL);
            break;
    }
}

INT_PTR CALLBACK
DialogProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hwnd, WM_PAINT, OnPaint);
        HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
    }
    return 0;
}

extern "C"
INT WINAPI
WinMain(
    HINSTANCE   hInstance,
    HINSTANCE   hPrevInstance,
    LPSTR       lpCmdLine,
    INT         nCmdShow)
{
    DialogBox(hInstance, MAKEINTRESOURCE(1), NULL, DialogProc);
    return 0;
}
